#include "../cpu/isr.h"
#include "../drivers/screen.h"
#include "../libc/mem.h"
#include "kernel.h"
#include "../libc/string.h"
#include "../cpu/types.h"
int debug = 0;
char bytearray[8] = {'0', '0', '0', '0', '0', '0', '0', '0'};
char *barray = bytearray;
void kernel_main() {
    isr_install();
    irq_install();

    clear_screen();
    kprint_at("Project Esperanto", 30, 0);
    kprint("\n> ");
}

void user_input(char *input) {
    if (strcmp(input, "EXIT") == 0) {
        kprint("It is now safe to turn off your computer...");
        asm volatile("hlt");
    } else if (strcmp(input, "VER") == 0) {
    	kprint("Komputilo OS v0.2.2\n");
    } else if (strcmp(input, "CLS") == 0) {
    	clear_screen();
    } else if (strcmp(input, "DEBUG FRUITCAKE") == 0) {
    	kprint("Debug activated!");
    	debug = 1;
    } else if (strcmp (input, "HELP") == 0) {
    	kprint("EXIT: Halts the CPU \n");
    	kprint("VER: Displays the version number \n");
    	kprint("CLS: Clears the screen\n");
    	kprint("HELP: Displays this menu\n");
    	kprint("DEBUG: Access special features (requires password after command)");
    } else if (strcmp(input, "PAGE") == 0) {
    	u32 phys_addr;
    	u32 page = kmalloc(1000, 3, &phys_addr);
    	char page_str[16] = "";
    	hex_to_ascii(page, page_str);
    	char phys_str[16] = "";
    	hex_to_ascii(phys_addr, phys_str);
    	kprint("Page: ");
    	kprint(page_str);
    	kprint(", physical address: ");
    	kprint(phys_str);
    	kprint("\n");
    } else if (strcmp(input, "TEST") == 0 && debug == 1){
    	kprint("Test");	
	} else if (strcmp(input, "WRITEBYTE 1") == 0 && debug == 1) {
		bytearray[7] = '1';
		kprint("BYTE 1 is 00000001");
	} else if (strcmp(input, "READBYTE 1") == 0 && debug == 1) {
		kprint(barray);
	} else {
    	kprint("Command not found");
    }
    kprint("\n> ");
}
